/*
    (C) 1995-98 AROS - The Amiga Research OS
    $Id: internalunloadseg.c,v 1.1.1.1 2005/03/15 15:54:40 laire Exp $

    Desc:
    Lang: english
*/
#include "dos_intern.h"
#include <proto/exec.h>
#include <aros/libcall.h>
#include <aros/asmcall.h>
#include <aros/machine.h>
#include <exec/libraries.h>

/*****************************************************************************

    NAME */
#include <proto/dos.h>

	AROS_LH2(LONG, InternalUnLoadSeg,

/*  SYNOPSIS */
        AROS_LHA(BPTR     , seglist , D1),
        AROS_LHA(VOID_FUNC, freefunc, A1),

/*  LOCATION */
        struct DosLibrary *, DOSBase, 127, Dos)

/*  FUNCTION

    INPUTS

    RESULT

    NOTES

    EXAMPLE

    BUGS

    SEE ALSO

    INTERNALS

    HISTORY
        27-11-96    digulla automatically created from
                            dos_lib.fd and clib/dos_protos.h

*****************************************************************************/
{
  AROS_LIBFUNC_INIT
  AROS_LIBBASE_EXT_DECL(struct DosLibrary *,DOSBase)

  BPTR next;

  DEBUG_LOADSEG(dprintf("InternalUnLoadSeg: seg = $%lx, func = $%lx\n", seglist, freefunc));

  FAILFORTASKNP(DEBUG_LOADSEG(dprintf("InternalUnLoadSeg() from task context failed!\n")); return FALSE;)

  if (seglist)
  {
    while (seglist)
    {
      next = *(BPTR *)BADDR(seglist);

      AROS_UFC3(void, freefunc,
        AROS_UFCA(APTR ,  (BPTR *)((LONG)BADDR(seglist) - sizeof(ULONG)), A1),
        AROS_UFCA(ULONG, *(LONG *)((LONG)BADDR(seglist) - sizeof(ULONG)), D0),
        AROS_UFCA(struct Library *, (struct Library *)SysBase           , A6)
      );
      
      seglist = next;
    }
    return DOSTRUE;
  }
  else
    return DOSFALSE;

  AROS_LIBFUNC_EXIT
} /* InternalUnLoadSeg */
